# all files / lighthouse-core/audits/ manifest-display.js

100% Statements 8/8
100% Branches 6/6
100% Functions 3/3
100% Lines 8/8

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63

    1×

    8×

    5×

    2×
    2×

    2×

    2×

    1×
     /**
     * @license
     * Copyright 2016 Google Inc. All rights reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    'use strict';

    const Audit = require('./audit');

    class ManifestDisplay extends Audit {
      /**
       * @return {!AuditMeta}
       */
      static get meta() {
        return {
          category: 'Manifest',
          name: 'manifest-display',
          description: 'Manifest\'s display property set to standalone/fullscreen to ' +
                'allow launching without address bar',
          requiredArtifacts: ['Manifest']
        };
      }

      /**
       * @param {string|undefined} val
       * @return {boolean}
       */
      static hasRecommendedValue(val) {
        return (val === 'fullscreen' || val === 'standalone');
      }

      /**
       * @param {!Artifacts} artifacts
       * @return {!AuditResult}
       */
      static audit(artifacts) {
        const manifest = artifacts.Manifest.value;
        const displayValue = (!manifest || !manifest.display) ? undefined : manifest.display.value;

        const hasRecommendedValue = ManifestDisplay.hasRecommendedValue(displayValue);

        return ManifestDisplay.generateAuditResult({
          value: hasRecommendedValue,
          rawValue: displayValue,
          debugString: 'Manifest display property should be standalone or fullscreen.'
        });
      }
    }

    module.exports = ManifestDisplay;